
#ifndef COMPONENTREF_H
#define COMPONENTREF_H

#include <kore/componentproxy.h>
#include <iostream>

namespace kore
{
    class Interface;
    class MetaInfo;

    class KORE_API ComponentRef
    {
    public:
        ComponentRef()
        {
            _proxy = 0;
            //cerr << "ComponentRef(): " << this << endl;
        }
        ComponentRef( ComponentProxy* proxy )
        {
            _proxy = proxy;
            //cerr << "ComponentRef( proxy: " << proxy << " ): " << this << endl;
        }
        ComponentRef( const ComponentRef& other )
        {
            _proxy = other._proxy;
            //cerr << "ComponentRef( other: " << &other << " ): " << this << endl;
        }
        ~ComponentRef()
        {
            //cerr << "~ComponentRef(): " << this << endl;
        }

        ComponentRef& operator=( const ComponentRef& other )
        {
            if( this != &other )
                _proxy = other._proxy;
            return *this;
        }

        Interface* instance() const
        {
            if( _proxy )
                return _proxy->instance();
            else
                return 0;
        }
        Interface* newInstance() const
        {
            if( _proxy )
                return _proxy->newInstance();
            else
                return 0;
        }

        MetaInfo* metaInfo() const
        {
            if( _proxy )
                return _proxy->metaInfo();
            else
                return 0;
        }

        ComponentProxy* proxy() const
        {
            return _proxy;
        }

        bool isValid() const
        {
            return _proxy != 0;
        }
    private:
        ComponentProxy* _proxy;
    };
};

#endif
