
#ifndef COMPONENTTRADER_H
#define COMPONENTTRADER_H

#include <kore/kore.h>
#include <kore/componentref.h>
#include <kore/interface.h>


namespace kore
{
    class ComponentTraderPrivate;

    class KORE_API ComponentTrader: public Interface
    {
    public:
        ComponentTrader();
        virtual ~ComponentTrader();

        virtual void registerComponent(const ComponentRef& provider);
        virtual void unregisterComponent(const ComponentRef& provider);
        virtual void registerComponents(const ComponentRef* providers);
        virtual void unregisterComponents();
        virtual const char** registeredServices() const;
        virtual ComponentRef* registeredComponents() const;
        virtual ComponentRef* registeredComponents(const char* service) const;
        virtual ComponentRef registeredComponent(const char* service) const;

        virtual void registerService( const char* service, const ComponentRef& provider );
        virtual void unregisterService( const char* service, const ComponentRef& provider );

        virtual unsigned long idAsLong( void* ) const;
        virtual unsigned long idAsLong( Interface* ) const;
        virtual const char* idAsString( void* ) const;
        virtual const char* idAsString( Interface* ) const;
        virtual const char* idAsService( void* ) const;
        virtual const char* idAsService( Interface* ) const;
        virtual ComponentRef idAsRef( void* ) const;
        virtual ComponentRef idAsRef( Interface* ) const;

        static ComponentRef traderRef();
    protected:
    private:
        ComponentTraderPrivate* _d;
    };
};

#endif
