
#ifndef LIBRARY_H
#define LIBRARY_H

#include <kore/kore.h>
#include <kore/interface.h>

namespace kore
{
    class LibraryPrivate;

    class KORE_API Library: public Interface
    {
    public:
        Library();
        Library(HMODULE handle, const char* libname, const char* libpath, int flags);
        virtual ~Library();

        virtual HMODULE libHandle() const;
        virtual const char* name() const;
        virtual const char* path() const;

        virtual void* symbolAddress( const char* name );
    private:
        LibraryPrivate* _d;
    };

};

#endif
