
#ifndef LIBRARYLOADER_H
#define LIBRARYLOADER_H

#include <kore/kore.h>
#include <kore/interface.h>

namespace kore
{

    class KORE_API Library;
    class LibraryLoaderPrivate;

    class KORE_API LibraryLoader: public Interface
    {
    public:
        enum { LAZY = 1, NOW, GLOBAL = 4};
        LibraryLoader();
        virtual ~LibraryLoader();
        virtual Library* loadLibrary(const char* libName, const char* libPath = 0, int libFlags = 0);
        virtual const char* lastError();
    
        virtual char* libName2fileName(const char* libName);
        virtual char* fileName2libName(const char* fileName);
    private:
        LibraryLoaderPrivate* _d;
    };

};

#endif

