
#ifndef METAINFO_H
#define METAINFO_H

#include <kore/kore.h>
#ifdef _WIN32
#include <map>
#include <iostream.h>
#else
#	if defined(__GNUC__) && __GNUC__ > 2
#		include <ext/hash_map>
#		include <ext/stl_hash_fun.h>
		using namespace __gnu_cxx;
#	else
#		include <hash_map>
#	endif
#endif
#include <set>

namespace kore
{
    class StringMultiMapPrivate;

    class KORE_API StringMultiMap
    {
    public:
        StringMultiMap();
        StringMultiMap( const char* avps[][2] );
        StringMultiMap( const char*** );
        virtual ~StringMultiMap();

        virtual void clear();
        virtual int size();
        virtual bool isEmpty();
        virtual void insert( const char* key, const char* value );
        virtual void insert( const char* avps[][2] );
        virtual void insert( const char*** avps );
        virtual void remove( const char* key, const char* value);
        virtual void removeAll( const char* key );
        virtual void replace( const char* key, const char* oldval, const char* newval );
        virtual void replaceAll( const char* key, const char* value );
        virtual int count( const char* key );
        virtual const char* find( const char* key );
        virtual const char** findAll( const char* key );
        virtual const char** keys();
        virtual const char*** elements();
    
        virtual void ddump();
    private:
        StringMultiMapPrivate* _d;
    };

    class MetaInfoPrivate;

    class KORE_API MetaInfo : public StringMultiMap
    {
    public:
        MetaInfo();
        MetaInfo( const char* avps[][2] );
        MetaInfo( const char*** );
        virtual ~MetaInfo();

    private:
        MetaInfoPrivate* _d;
    };
};

#endif // METAINFO_H

